--- dillo-0.8.6.orig/src/html.c	2006-04-12 17:50:35.000000000 +0200
+++ dillo-0.8.6/src/html.c	2007-02-28 13:14:52.000000000 +0100
@@ -407,6 +407,10 @@
       gtk_menu_popup(GTK_MENU(bw->menu_popup.over_image), NULL, NULL,
                      NULL, NULL, event->button, event->time);
       return TRUE;
+   } else if(event->button == 1 && image->url && 
+		   ( (image->height*8)>image->width && 
+		      image->height<(image->width*8) ) ) {
+     a_Nav_push(bw, image->url);
    }
 
    return FALSE;
diff -Naur dillo-0.8.6.orig/src/interface.c dillo-0.8.6/src/interface.c
--- dillo-0.8.6.orig/src/interface.c	2005-12-02 13:40:44.000000000 +0100
+++ dillo-0.8.6/src/interface.c	2007-02-26 17:05:28.000000000 +0100
@@ -183,8 +183,7 @@
    /* Back and Forward buttons */
    back_sensitive = a_Nav_stack_ptr(bw) > 0;
    gtk_widget_set_sensitive(bw->back_button, back_sensitive);
-   forw_sensitive = (a_Nav_stack_ptr(bw) < a_Nav_stack_size(bw) - 1 &&
-                     !bw->nav_expecting);
+   forw_sensitive = 1;
    gtk_widget_set_sensitive(bw->forw_button, forw_sensitive);
 
    bw->sens_idle_id = 0;
diff -Naur dillo-0.8.6.orig/src/nav.c dillo-0.8.6/src/nav.c
--- dillo-0.8.6.orig/src/nav.c	2006-01-02 19:17:23.000000000 +0100
+++ dillo-0.8.6/src/nav.c	2007-02-28 17:00:57.000000000 +0100
@@ -306,7 +306,7 @@
 /*
  * Send the browser to next page in the history list
  */
-void a_Nav_forw(BrowserWindow *bw)
+void a_Nav_forw2(BrowserWindow *bw)
 {
    gint idx = a_Nav_stack_ptr(bw);
 
@@ -318,6 +318,59 @@
 }
 
 /*
+ * Increment the last digit of the last number in the URL 
+ * Sorry for the code: it's a quick hack.
+ */
+
+void a_Nav_forw(BrowserWindow *bw)
+{
+	int forw_sensitive;
+	DilloUrl *new;
+	gchar *str;
+	gint i,n;
+	/* check if there are pages in the history */
+	forw_sensitive = (a_Nav_stack_ptr(bw) < a_Nav_stack_size(bw) - 1 &&
+			                     !bw->nav_expecting);
+	if(forw_sensitive) {
+		a_Nav_forw2(bw);
+		return;
+	}
+	/* get the current url and serach for the last number */
+	str=malloc(strlen(a_Url_str(a_History_get_url(NAV_IDX(bw,a_Nav_stack_ptr(bw)))))+2);
+	strcpy(str,a_Url_str(a_History_get_url(NAV_IDX(bw,a_Nav_stack_ptr(bw)))));
+	for(i=0;str[i]!='\0';i++)
+		;
+	for(;i>=0;i--) {
+		if(str[i]>='0' && str[i]<='9')
+			break;
+	}
+	if(i<0)
+		return; /* no numbers in URL */
+	/* add 1 to the last number of the URL, enlarging its length is neccessary */	
+	n=1;
+	do {
+		str[i]=str[i]+n;
+		if(str[i]>'9')
+			str[i]='0',n=1;
+		else
+			n=0;
+		i--;
+	} while(i>=0 && n>0 && str[i]>='0' && str[i]<='9');	
+	if(n>0) {
+		i++;
+		memmove(str+i+1,str+i,strlen(str+i));
+		str[i]=n+'0';
+		n=0;
+	}
+	/* Push the new URL into the history to make dillo load it */
+	new=a_Url_new(str,NULL, 0, 0, 0);
+   	a_Nav_push(bw, new);
+	a_Url_free(new);
+	free(str);
+}
+
+
+/*
  * Redirect the browser to the HOME page!
  */
 void a_Nav_home(BrowserWindow *bw)
